﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using PetaPoco;
using Seminar;

namespace Fun
{
    public partial class Form1 : Form
    {
        private List<tblStudent> students; 

        public Form1()
        {
            InitializeComponent();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            tblStudent studentTable = new tblStudent();
            studentTable.StudentId = Guid.NewGuid();
            studentTable.FirstName = txtFirstName.Text;            
            studentTable.LastName = txtLastName.Text;
            studentTable.Major = txtMajor.Text;
            studentTable.DateEntered = DateTime.Now;

            var db = new PetaPoco.Database("Seminar");

            db.Insert(studentTable);
            UpdateStudentList();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var db = new PetaPoco.Database("Seminar");

            db.Delete(selectedStudent);
            UpdateStudentList();
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {
            tblStudent studentTable = new tblStudent();
            studentTable.FirstName = txtFirstNameUpdate.Text;
            studentTable.LastName = txtLastNameUpdate.Text;
            studentTable.Major = txtMajorUpdate.Text;
            studentTable.StudentId = selectedStudent.StudentId;
            studentTable.DateEntered = DateTime.Now;

            var db = new PetaPoco.Database("Seminar");

            db.Update(studentTable);
            UpdateStudentList();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //initialize the students
            UpdateStudentList();

        }

        private void UpdateStudentList()
        {
            //read all students from the db
            var db = new PetaPoco.Database("Seminar");            
            var sql = "SELECT * FROM tblStudent";
            students = new List<tblStudent>(db.Query<tblStudent>(sql));

            cboStudents.Items.Clear();
            cboStudents.DisplayMember = "FirstName";

            foreach (var tblStudent in students)
            {
                cboStudents.Items.Add(tblStudent);
            }

        }

        private tblStudent selectedStudent = null;
        private void cboStudents_SelectedIndexChanged(object sender, EventArgs e)
        {
            selectedStudent = (tblStudent)cboStudents.SelectedItem;
            txtFirstNameUpdate.Text = selectedStudent.FirstName;
            txtLastNameUpdate.Text = selectedStudent.LastName;
            txtMajorUpdate.Text = selectedStudent.Major;
        }

    }
}
